2021-03-17  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.0

2021-03-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Check for unused attributes unconditionally

	vapi: Fix a couple of attribute typos

	gio-2.0: Add some missing NoWrapper and CCode.has_typedef attributes

	girparser: Add support for NoWrapper metadata for methods

	codegen: Include "glib.h" for deprecated symbols (GOBJECT)
	It is required for G_GNUC_DEPRECATED in declarations of
	enums, delegates, methods, property accessors and structs.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1155

2021-03-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4-unix-print: Switch to gir
	Use a temporary symlink to Gtk-4.0.gir which includes the required
	symbol defintions.

	girparser: Handle empty "<type/>" element and report an error

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 4.1.2

	webkit2gtk-4.0: Update to 2.31.91

2021-03-14  Rico Tzschichholz  <ricotz@ubuntu.com>

	build: Add --enable-test-asan configure option
	List XFAIL tests if address sanatizer is enabled

	linux: Provide Input.Event.input_event_sec/input_event_usec fields
	Mark Input.Event.time as deprecated

	See https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit?id=152194fe9c3f

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1152

	vala: Improve error for incompatible expressions in conditional expression

	gsl: Fix more binding errors

	girparser: Allow overriding of "Compact" attribute for classes

	gtk4: Add Gtk.INVALID_LIST_POSITION
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1151

2021-03-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	gsl: Fix some binding errors

	gnutls: Fix some binding errors

2021-03-10  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.91

	vapi: Update GIR-based bindings

	vala: Replace all type parameter occurances in parameters for signal delegate
	Improves 36999b5ffd63cc56a8648791b02bf07e7da88077

	codegen: Drop inner casts before converting between generics and integers
	Found by -Wpointer-to-int-cast

2021-03-09  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't add generics arguments/parameters to async finish method

	codegen: Don't ever create null-aware free macro for GenericType

	tests: Add "string concat" test for POSIX to increase coverage

	codegen: Fix access to captured generics in async method of interfaces
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/537

	codegen: Use the one available source_reference for internal error
	This will at least provide some pointer to where things are going wrong.

	In addition to 837d593e00d1a3ca8a6f2d13fb1514bed7672965

	See https://gitlab.gnome.org/GNOME/vala/issues/436

	codegen: Free intermediate temp-variables of postcondition expression
	and not clearing "temp_ref_values" caused invalid references later.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/80

2021-03-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Report error for missing type-arguments of HashTable (de)serialization
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1147

	vala: Check (optional) type-arguments of array creation expression

	vala: Check array type of declarations for errornous type-arguments

	vala: Move type-argument/-parameter count check to DataType.check_type_arguments()

	gio-2.0: Add some missing type-arguments

	glib-2.0: Add some missing type-arguments

	vala: Add missing null-check in DataType.get_type_signature()
	If an instance struct field can not be resolved to a valid
	type-signature then bail.

	This fixes criticals like:

	    g_string_insert_len: assertion 'len == 0 || val != NULL' failed

2021-03-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.90

	gdbus: Don't leak memory of deserialized arguments on error in wrapper method
	Found by -fsanitize=address

	gtk4: Update to 4.1.1+f8f90d85

	vala: Fix ownership inheritance of "unowned var" in foreach statement

2021-03-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "gir" tests to increase coverage

	testrunner: Include Gio-2.0/gio-2.0 for GIR tests too

	Use pre-resolved symbol/type of SemanticAnalyzer if possible

	codegen: More use of get_ccode_type_name()

	codegen: Inherit GType from base struct of SimpleType structs
	GValue functions and marshaller type are inherited from base structs
	already.

	This avoids invalid C code which referenced an unavailable GType.

2021-03-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "gir" tests to increase coverage

	Regenerate GIR-based bindings to pick up missing class methods

	girparser: Evaluate "glib:type-struct" twice to pick up reparented structs

	codegen: "_first_array" parameter for params-array is variadic too
	Not following this resulted in mismatching signature assumptions between
	caller and callee if the callable throws an error.

2021-03-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Extend "pre-post increment" test to increase coverage

	tests: Add "target-glib=auto" tests to increase coverage

	tests: Add some tests to increase coverage

	vala: Fix build with valac < 0.44

	vala: Report warning if --target-glib=auto was not evaluated successfully
	and don't try to process the valid "auto" string any further.

	codegen: More use of get_ccode_type_name()

	Regenerate GIR-based bindings to pick up missing type_cname attributes

	girparser: Reuse populated Node.gtype_struct_for instead of resolving again
	This fixes the discovery of non-default type_cname for re-parented symbols.

2021-02-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.3

	vapi: Update GIR-based bindings

	glib-2.0: Add new symbols from 2.68

	webkit2gtk-4.0: Update to 2.31.90

	tests: Add some "unary expressions" tests to increase coverage

	vala: Report error for invalid inner operand of unary expressions
	This fixes criticals like:

	    vala_unary_expression_is_integer_type: assertion 'type != NULL' failed

	vala: Set proper source_reference for implicit "this" and "result" variables

	tests: Add more "unsupported creation method" tests to increase coverage

2021-02-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Include "stdlib.h" for Enum.to_string() (POSIX)
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1143

	codegen: Include "string.h" for strcmp() (POSIX)

	vala: Improve context check whether property is writeable on assignments

2021-02-24  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't wrongly emit declaration for default-handler of signals
	This is done in GTypeModule.generate_interface_declaration()

2021-02-22  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

2021-02-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "girparser" tests to increase coverage

	vala: Don't allow "in" operation with different enum types
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1139

	vala: Infer needle type for "in" expression on enum
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1138

2021-02-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests/girwriter: Increase coverage

	girwriter: Output default handler of signals

2021-02-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: CCodeBaseModule.get_type_id_expression () won't return null

	vala: Generics value holding struct pointer requires casting on access
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/347

	codegen: Don't use volatile modifier in glib API when targetting >= 2.68
	See https://gitlab.gnome.org/GNOME/glib/merge_requests/1719

2021-02-18  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.2

2021-02-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Properly parse and handle chained initialization of members
	Make MemberInitializer an Expression, so it is possible to descibe
	nested/chained member initializers in the AST.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1137

	vala: Move SemanticAnalyzer.vist_member_initializer() to MemberInitializer

	vala: Simplify Expression.parent_statement

	codegen: Report error for unsupported symbol_reference of MemberInitializer

	vala: Capturing va_list parameters/variables is not allowed
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1136

	codewriter: Don't write trailing ";" after body of WithStatement

	codewriter: Output valid vala syntax for LoopStatement

2021-02-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

	gstreamer: Update from 1.19.0+ git master

2021-02-13  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Include type-checks in preconditions of methods for type narrowing
	See https://gitlab.gnome.org/GNOME/vala/issues/894

	vala: Check type-arguments in base-types/prerequisites of class/interface
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/404

2021-02-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.1

2021-02-08  Rico Tzschichholz  <ricotz@ubuntu.com>

	sdl2: Fix a couple of binding errors and attribute issues

	codegen: Include <string.h> for memcpy usage in _vala_memdup2()

2021-02-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Strip all nested occurances of CCodeCastExpression
	Triggered by 63551acaf0d83fac8b50904c2759c1098fbfaa71

	See https://gitlab.gnome.org/GNOME/vala/issues/1134

	build: Ease source for AC_LANG_SOURCE of CGRAPH check

	libvaladoc: Add wrapper for "agedge" of graphviz

	codegen: Correctly retrieve symbol_reference of nested cast expressions
	Regression of 63551acaf0d83fac8b50904c2759c1098fbfaa71

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1134

2021-02-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Add libunwind-generic binding

	gio-2.0: Update to 2.67.3

	gtk4: Update to 4.1.0+2712f536

	gstreamer: Update from 1.19.0+ git master

2021-02-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	gee: Replace Memory.dup() with GLib.malloc() and Memory.copy()

	gstreamer-1.0: Set CCode.type_id of MiniObject to G_TYPE_BOXED
	Fixed https://gitlab.gnome.org/GNOME/vala/issues/1133

2021-02-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Replace "g_memdup" with "_vala_memdup2" for target glib < 2.68
	"_vala_memdup2" is a copy of "g_memdup2" available in glib >= 2.68

	glib-2.0: Add new symbols from 2.68

	codegen: Use g_memdup2 if target glib >= 2.68 is set
	See https://gitlab.gnome.org/GNOME/glib/issues/2319

	testrunner: Add "-Werror=return-stack-address" flag

	vala: Add Block.unreachable_exit and have it set accordingly by FlowAnalyzer
	Use this control flow information in codegen rather than doing an
	educated guess based on occurring ReturnStatement nodes.

	See https://gitlab.gnome.org/GNOME/vala/issues/838

	tests: Don't leak array if length is -1
	Found by -fsanitize=address

	codegen: Chain up to base struct destroy function
	Found by -fsanitize=address

2021-02-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't leak memory moving heap-allocated struct to stack
	Found by -fsanitize=address

	codegen: Use temp_ref_values list instead of patching the AST
	Simplyfies 5328619a8141aa11341d479428ebfdcec0ff9756

	codegen: Don't leak GLib.Value when implicitly unboxing it
	Found by -fsanitize=address

	vala: Don't allow GLib.Value casting to nullable struct/simple types

	vala: GLib.Value unboxing returns unowned value

	codegen: Use g_boxed_free in free-wrapper for heap-allocated GLib.Value
	dup-wrapper is specifically using g_boxed_copy already

2021-02-02  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't leak array memory after it was implicitly copied
	Found by -fsanitize=address

2021-02-01  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Improve handling of recursive DelegateType
	Move dedicated test case into a separate file

	codegen: Make sure types of implicit delegate parameters are declared

	codegen: Use CCodeDeclaratorSuffix to emit array length of constants

	ccode: Minor API cleaning and additions

	vala: Rename Loop to LoopStatement and introduce a common base class

	codegen: Also check array type of variable argument for ref parameters

	codegen: Add get_ccode_no_wrapper() and use it

2021-01-31  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Set CCode.type_cname for classes if it doesn't match our default

	tests/girwriter: Add tests for async methods attributed with NoWrapper

	codegen: Don't emit invoker for async methods attributed with NoWrapper

	libxml-2.0: Fix a few binding errors

	fuse: Fix a few binding errors

2021-01-30  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Always use G_TYPE_INSTANCE_GET_CLASS/INTERFACE for external symbols
	and get_ccode_type_get_function() for SourceFileType.SOURCE symbols.

	codegen: Handle NoWrapper attribute of async methods on caller side

	codegen: Allow CCode.type_cname for classes and use get_ccode_type_name()

	girparser: Apply "type_get_function" metadata for classes and inferfaces

	codegen: Add CCode.type_get_function and get_ccode_type_get_function()
	Allow to overide the macro name, and join get_ccode_class_get_function ()
	and get_ccode_interface_get_function().

	gtk+-2.0,javascriptcoregtk-4.0: Wrong usage of CCode.type_cname attribute

	girwriter: Don't emit invoker for methods attributed with NoWrapper

	codegen: Don't emit invoker for methods attributed with NoWrapper

	codegen: Handle NoWrapper attribute of interface methods on caller side

	vala: NoWrapper methods must be declared abstract or virtual

	gio-2.0: Pick up missing invoker for some AppInfo/File.*() methods

	gdk-pixbuf-2.0: Fix Pixbuf.save_to_streamv_async()

	gobject-2.0: Fix a few binding errors

	gdk-3.0,gdk-x11-3.0,gtk+-3.0,gtk4: Fix a few binding errors

2021-01-28  Rico Tzschichholz  <ricotz@ubuntu.com>

	Add further support for params arrays in constructors
	In addition to 98ab3da89640b8b8a6c67044b4df1194672774bb

	See https://gitlab.gnome.org/GNOME/vala/issues/128

2021-01-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Improve support of SimpleType struct constructors
	Additionally stop generating broken and superfluous dup/free functions,
	and don't create not used GType declarations.

	vala: Don't allow disposable SimpleType structs

	gstreamer-1.0: Fix a few binding errors

	posix: Fix a few binding errors

	libgvc: Fix a few binding errors

	sqlite3: Fix a few binding errors

	bzlib: Fix a few binding errors

	alsa: Fix a few binding errors

	curses: Fix a few binding errors

2021-01-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Apply "destroy_notify_cname" metadata for fields

	vala: Add CallableExpression interface for MethodCall/ObjectCreationExpression

	goocanvas-2.0: Fix some field types

	pango: Fix a few binding errors

	gobject-2.0: Fix a few binding errors

	gio-2.0,gtk+-3.0,gtk4: Drop explicit c-type attributes of va_list parameters

	gio-2.0: Fix binding of PollableOutputStream.write*_nonblocking()

	cairo: Fix some ctor binding errors

2021-01-25  Rico Tzschichholz  <ricotz@ubuntu.com>

	cairo: Fix a few binding errors

	gtk+-3.0,gtk4: Fix some delegate return values and parameters

	girparser: Apply "delegate_target" metadata for methods and parameters

	vala: Don't prepend "unowned" in VarType and leave that to the CodeWriter

	codewriter: Append new-line for nested block statements

2021-01-23  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Apply stricter condition for lambda to delegate assignment
	This moves an internal codegen error to the semantic-analyzer.

	codegen: Clean up expression casts in CCodeAssignmentModule.visit_assignment()

2021-01-22  Ole André Vadla Ravnås  <oleavr@gmail.com>

	vala: Avoid critical when trying to use symbol_reference of ElementAccess
	Regression of 6e7be51cb5455e9c5c721d4ba5121a6ab04673dd

2021-01-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "parser" tests to increase coverage

2021-01-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Improve prototype-string of CallableType

	Update THANKS from git log

	valadoc: Replace png icons with elementary's svg version
	These match what was introduced by 8af8158c106eaafe12a628514f74e5788274d8d2

	The icons were written by Daniel Foré for valadoc.org. They were taken from
	https://github.com/Valadoc/valadoc-org

	vapi: Update GIR-based bindings

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 4.0.2

2021-01-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Discover our very own array length fields

	vala: Make Class.is_compat/is_immutable/is_singleton read-only

	libvaladoc: Correctly retrieve value for Api.Class.is_compact

2021-01-19  Simon Werbeck  <simon.werbeck@gmail.com>

	Add support for 'opaque' compact classes
	This change intruduces a new attribute switch [Compact (opaque = true)]
	which allows to completely hide the implementation of a compact class.
	This is especially useful for libraries when maintaining a stable abi.

	An 'opaque' compact class exposes no struct definition in the generated
	c header, only a typedef is provided. As such, certain requirements
	apply for members of such classes:
	- Access to instance fields must be either private or internal.
	- No abstract/virtual methods or properties are allowed.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1129

2021-01-18  Rico Tzschichholz  <ricotz@ubuntu.com>

	girwriter: Write instance-parameter elements
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1128

	tests: Extend "girparser" test and use vapigen to parse generated gir

	vala: Let method representing property accessor inherit GIR.visible attribute

	vala: Set this_parameter of method representing property accessor

2021-01-17  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more invalid "GtkTemplate" tests to increase coverage

	vala: Don't allow assigning GtkChild fields/properties
	These are handled exclusively by GtkBuilder

	See https://gitlab.gnome.org/GNOME/vala/issues/1121

2021-01-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: GtkChild fields/properties must be declared as unowned
	The backing field won't be assigned to hold a dedicated reference.
	gtk_widget_class_bind_template_child_full will make it point to the
	instance owned by GtkBuilder.

	This avoids doing a rogue (but safe) call of _g_object_unref0 on already
	disposed child.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1121

2021-01-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	libvaladoc/html: Don't sort struct fields to keep their original order
	This follows their special handling done in Codewriter.visit_struct().

	In addition to a336d75586acb534aff55ca86425eb8f3aa45de4

2021-01-15  Reuben Thomas  <rrt@sc3d.org>

	libvaladoc: Fix typos copyright year

2021-01-14  Reuben Thomas  <rrt@sc3d.org>

	glib-2.0: Improve type of OptionEntry.flags field

2021-01-14  Rico Tzschichholz  <ricotz@ubuntu.com>

	Regenerate GIR-based bindings

	gdk-pixbuf-2.0: Update to 2.42.3~

	girparser: Minor improvement to field getter detection
	Allow DataType.compatible() to be called without initialized SemanticAnalyzer

	Additionally report a warning if field collides with method

	girparser: Handle anonymous delegate not backed by virtual-method or signal

2021-01-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	webkit2gtk-4.0: Update to 2.31.1

	vala: Improve detection of duplicate package source files

2021-01-11  Rico Tzschichholz  <ricotz@ubuntu.com>

	Sync NEWS from 0.50

2021-01-09  Rico Tzschichholz  <ricotz@ubuntu.com>

	gio-2.0: Update to 2.67.2+46097e9b

	gtk4: Update to 4.0.1

2021-01-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Fix assignment of casted struct value to property
	Usage of address-of operator requires lvalue access. Therefore use a
	temporary variable to be passed to property setter.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1126

2021-01-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

	gstreamer: Update from 1.19.0+ git master

2021-01-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	gio-2.0: Update to 2.67.1+2bd86268

	gobject-2.0: Add new symbols from 2.68

	glib-2.0: Add new symbols from 2.68

2021-01-02  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add "string switch" test to increase coverage

2021-01-01  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "array field initializer" tests to increase coverage

	codegen: Don't leak memory on internal value comparison of property setter

2020-12-31  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't leak memory of already assigned out-parameter on error
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1123

2020-12-30  Rico Tzschichholz  <ricotz@ubuntu.com>

	glib-2.0: Make PtrArray a subclass of GenericArray

2020-12-30  Simon Werbeck  <simon.werbeck@gmail.com>

	codegen: Support chain up to simple generics constructor
	This allows subclassing bindings like GLib.HashTable and GLib.Sequence
	that require implicit DestroyNotify parameters to chain up.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/342

2020-12-30  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Clean up handling of type parameters in generate_cparameters()

	codegen: Drop superfluous "method_has_wrapper" helper

	codegen: Use CCodeInvalidExpression instead of place holders

	tests: Add "array creation" tests to increase coverage

2020-12-29  Mario Daniel Ruiz Saavedra  <desiderantes93@gmail.com>

	SDL2_image: Add save functions
	Add save functions for JPG and PNG formats.

2020-12-29  Chris White  <cxwembedded@gmail.com>

	gstreamer-1.0: Fix direction of Gst.Iterator.fold() ret parameter
	See https://gitlab.gnome.org/GNOME/vala/issues/1014

2020-12-28  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4: Update to 4.0.0+0fcf01dd

	vala: Ownership transfer of inline-allocated array is not allowed
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/931

2020-12-22  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4: Don't rename binding for gtk_css_provider_load_from_data
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1117

2020-12-22  Ulrich Küttler  <kuettler@gmail.com>

	vala: SliceExpression need to return heap-allocated or unowned references
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1120

2020-12-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: value_type of PointerIndirection expressions must not be owned
	A member-access making the wrong assumption of a previous copy resulted
	in a double free.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1118

	codewriter: Wrap AddressofExpression and PointerIndirection in parens

	vala: Add missing TraverseVisitor.visit_addressof_expression()

	vala: Use common visitor schema for PointerIndirection expressions
	Not doing so breaks assumptions of the CodeWriter leading to a mangled
	output.

2020-12-17  Mario Daniel Ruiz Saavedra  <desiderantes93@gmail.com>

	SDL2_ttf: Add some missing methods for the Font class
	Migrate existing methods to use GLib types instead of arrays
	(string16, unichar, unichar2) and fix some code style issues.

2020-12-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4: Update to 4.0

2020-12-11  Rico Tzschichholz  <ricotz@ubuntu.com>

	webkit2gtk-4.0: Update to 2.30.3

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 3.99.5.1+2d3a3986

2020-12-10  Chris White  <cxwembedded@gmail.com>

	gstreamer-1.0: Fix direction of GLib.Value typed parameters
	Use `out` for functions that take an uninitialized GLib.Value.
	Use `ref` for functions that take a GLib.Value initialized with
	a particular type.

	Remove unused Gst.ControlBindingConvert

	Note that the destination is nullable, but not expressly marked as such,
	in gst_value_intersect, gst_value_subtract and
	gst_message_parse_property_notify.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1014

2020-12-09  Reuben Thomas  <rrt@sc3d.org>

	vapi: Add enchant-2 bindings for Enchant 2.x

2020-12-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Report an error if gio-2.0 is missing for DBus support

2020-12-02  Christopher White  <cwhite@d3engineering.com>

	glib-2.0: Bind assert_cmp* functions
	Add assert_cmpstr, assert_cmpint, assert_cmpuint, assert_cmphex,
	assert_cmpfloat, assert_cmpfloat_with_epsilon and assert_cmpvariant.

	Add enum GLib.CompareOperator which defines the supported operators.

	  "g_assert_cmpint(foo,==,1)" translates to "assert_cmpint(foo, EQ, 1)"

	Based on patch by Luca Bruno

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/395

2020-12-02  Reuben Thomas  <rrt@sc3d.org>

	vapi: Add gnu.vapi with binding for getopt_long() and some other GNU APIs

2020-11-28  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4: Use correct cheader_include for wayland/x11 gdk backend
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1112

2020-11-25  Rico Tzschichholz  <ricotz@ubuntu.com>

	glib-2.0: Add GLib.[S]List.is_empty() convenience methods for non-null

2020-11-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	Sync NEWS from 0.50

	manual: Update from wiki.gnome.org

	gio-2.0: Update to 2.67.0+6e9ed964

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 3.99.4+7551f85d

2020-11-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Apply CCodeModifiers.PRINTF to "string_printf" (POSIX)
	Found by clang with "posix/string-printf" test

	ccode: Use __attribute__ replacements of G_GNUC_* for posix profile

2020-11-14  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add "translated string constant" test to increase coverage

	tests: Add "constructor with inner error" test to increase coverage

	tests: Add string.printf() test to increase coverage

	tests: Add more "delegate" tests to increase coverage

	codegen: Drop obsolete dedicated handling of property value-parameter

	Revert errornous git push
	This reverts commit 9319f309dd97532a3174de995a83884739d70460.
	This reverts commit 9ccdd25eaf0c57ac0cb18380b81d76a9d7113f7f.
	This reverts commit 6689c356dade08a0d04a4d6f3add15a71125e925.
	This reverts commit 4f560d0bb2753bed14b2f0688f2d3e686a39d6ca.

	DEBUG

	vala: More copying of dedicated data-type instances for code-nodes

	vala: Require a valid DataType instance for every TargetValue

	codegen: Use Expression.target_type/value_type in visit_cast_expression()
	CastExpression.type_reference is meant to hold the actual target type.

	codegen: Improve GValueModule.visit_cast_expression()
	Re-use the result of the GValue-getter invocation

	vala: Properly restore SemanticAnalyzer.current_symbol to its original value

	vala: Make sure parent_symbol for special async parameters is available

	vala: Cache async parameter lists of coroutine methods

2020-11-14  Arne Hoch  <derhoch@gmail.com>

	linux: Add missing struct in cname for Spi.IocTransfer
	There is no typedef, so "struct spi_ioc_transfer" needs to be used.

2020-11-11  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapigen: Avoid superfluous cast

	vala: Add support for type narrowing
	This causes type of given variable to be narrowed for the correspoding
	child block of an if-statement.

	Foo foo = ...;
	if (foo is Bar) {
	    // foo represents a non-null Bar instance inside this block
	}

	This makes conditional-expressions behaving similar.

	... = (foo is Bar) ? "foo is instance of Bar here" : "...";

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/894

2020-11-10  Reuben Thomas  <rrt@sc3d.org>

	posix: Add POSIX, GNU and BSD Regex APIs
	The POSIX and GNU APIs are closely related in GNU’s implementation, so it
	makes sense to put them here. GNU regex also provides the old BSD APIs,
	which are just a couple of function calls, so provide them too.

	posix: Add freopen binding, as FILE.reopen()

2020-11-10  Rico Tzschichholz  <ricotz@ubuntu.com>

	glib-2.0: Improve GenericArray.length property

2020-11-10  Corentin Noël  <corentin@elementary.io>

	codegen: Report internal error for unsupported collection type in foreach

2020-11-10  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Accept "unowned var" as type for foreach variable declaration
	In addition to 39331e235f1183223c8ea685e3501ab4ca932c8f

	See https://gitlab.gnome.org/GNOME/vala/issues/152

	vala: Avoid taking extra reference of foreach collection for index iteration

2020-11-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	gstreamer: Update from 1.19.0+ git master

2020-11-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4: Update to 3.99.4+0d82faa2

2020-11-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	girwriter: Infer gir_namespace/version from target GIR filename
	See https://gitlab.gnome.org/GNOME/vala/issues/606

	Perform runtime version check of libvala
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/88

	tests: Actually export PKG_CONFIG_PATH and LD_LIBRARY_PATH in tests extra

2020-11-05  Corentin Noël  <corentin@elementary.io>

	glib-2.0: Add GenericArray.find_custom() as variant of find_with_equal_func()
	This allows the needle to be a different type as the actual element type.
	The implementation of ArraySearchFunc<G,T> is more customizable this way.

2020-11-05  Reuben Thomas  <rrt@sc3d.org>

	testrunner: A lot of simplifications

	tests: Use Automake’s parallel test driver to speed up running tests
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1094

2020-11-02  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Use DataType.compatible() to check for string concatenation
	Make the checks match the ones performed by the code-generator to prevent
	invalid c-code to be created.

	See https://gitlab.gnome.org/GNOME/vala/issues/1100

2020-10-28  Mario Daniel Ruiz Saavedra  <desiderantes93@gmail.com>

	vapi: Add SDL 2.x bindings
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1032

	vapi: Remove SDL 1.x bindings
	See https://gitlab.gnome.org/GNOME/vala/issues/1032

2020-10-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	valadoc: Correctly set verbose flag on CodeContext

	libvaladoc/girimporter: Skip "docsection" elements in <namespace>
	See https://gitlab.gnome.org/GNOME/gobject-introspection/-/merge_requests/226

2020-10-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Make use of new printf-like API of Report.*()

	codegen: Make use of new printf-like API of Report.*()

	vala: Convert Report.*() to real printf-like functions
	This simplifies code on the caller side.

	valadoc: Refactor setup of main runtime

2020-10-25  Rico Tzschichholz  <ricotz@ubuntu.com>

	curses: Correctly use [PrintfFormat] attribute

	valadoc: Don't call CodeContext.pop() on empty stack
	Otherwise this results in an expected assertion.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1064

2020-10-24  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: CodeNode.source_reference is optional, so let the API respect that

2020-10-23  Jeremy Philippe  <jeremy.philippe@gmail.com>

	codegen: More use of delegate_target_type and delegate_target_destroy_type (2)

2020-10-22  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Update outdated array _size_ variable of captured local-variable
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1090

	gtkmodule: Support "binding" to bind GtkCallback to class of given property
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1093

2020-10-21  Reuben Thomas  <rrt@sc3d.org>

	curses: Add Terminfo API set, function keycodes F(n) and minor changes
	Some terminfo-related API were already bound (mvcur, vidattr, vidputs);
	move these all together, and add missing symbols (all from term.h).
	Bind the “F(n)” macro for function key codes.
	Annotate VidputsPutcFunc for correct C generation.
	Add attribute A_ITALIC (ncurses extension).

